package milab.lab01.fooagent;

import milab.*;
import javax.xml.bind.*;
import java.util.List;

class fooagent {
	  
	public static void main (String[] argv) {

		String mode					= argv[0];
		String xmlDocument	= argv[1];
		
		DataHandler.writeString2File(xmlDocument+"_", "abcd-ABCD - 4321");
		
		// ********************************************************************
		// *************** Java Object ---> XML file, or String ***************
		// ********************************************************************
		if (mode.equals("writefile")) {	
			
			// ------------------- JAVA OBJECT ---------
			ObjectFactory factory = new ObjectFactory();
			
			CatalogType catalog = factory.createCatalogType();
	
			catalog.setSection("Java Technology");
			catalog.setPublisher("IBM developerWorks");
			
			JournalType journal = factory.createJournalType();
			
			ArticleType article = factory.createArticleType();
			
			article.setLevel("Intermediate");
			article.setDate("January-2004");
			article.setTitle("Service Oriented Architecture Frameworks");
			article.setAuthor("Naveen Balani");
			
			java.util.List journalList = catalog.getJournal();
			journalList.add(journal);
			java.util.List articleList = journal.getArticle();
			articleList.add(article);
			
			article = factory.createArticleType();
			
			article.setLevel("Advanced");
			article.setDate("October-2003");
			article.setTitle("Advance DAO Programming");
			article.setAuthor("Sean Sullivan");
			
			articleList = journal.getArticle();
			articleList.add(article);
			
			article = factory.createArticleType();
			
			article.setLevel("Advanced");
			article.setDate("May-2002");
			article.setTitle("Best Practices in EJB Exception Handling");
			article.setAuthor("Srikanth Shenoy");
			
			articleList = journal.getArticle();
			articleList.add(article);
			
			JAXBElement<CatalogType> catalogElement = factory.createCatalog(catalog);
			// ------------------- JAVA OBJECT --------------------------------------					
			
			JAXBMarshaller jaxbMarshaller = new JAXBMarshaller();
			jaxbMarshaller.generateXMLDocument(xmlDocument, catalogElement, "milab.lab01.fooagent");
		
		} else if (mode.equals("writestring")) {

			// ------------------- JAVA OBJECT ---------
			ObjectFactory factory = new ObjectFactory();
			
			CatalogType catalog = factory.createCatalogType();
	
			catalog.setSection("Java Technology");
			catalog.setPublisher("IBM developerWorks");
			
			JournalType journal = factory.createJournalType();
			
			ArticleType article = factory.createArticleType();
			
			article.setLevel("Intermediate");
			article.setDate("January-2004");
			article.setTitle("Service Oriented Architecture Frameworks");
			article.setAuthor("Naveen Balani");
			
			java.util.List journalList = catalog.getJournal();
			journalList.add(journal);
			java.util.List articleList = journal.getArticle();
			articleList.add(article);
			
			article = factory.createArticleType();
			
			article.setLevel("Advanced");
			article.setDate("October-2003");
			article.setTitle("Advance DAO Programming");
			article.setAuthor("Sean Sullivan");
			
			articleList = journal.getArticle();
			articleList.add(article);
			
			article = factory.createArticleType();
			
			article.setLevel("Advanced");
			article.setDate("May-2002");
			article.setTitle("Best Practices in EJB Exception Handling");
			article.setAuthor("Srikanth Shenoy");
			
			articleList = journal.getArticle();
			articleList.add(article);
			
			JAXBElement<CatalogType> catalogElement = factory.createCatalog(catalog);
			// ------------------- JAVA OBJECT --------------------------------------		
			
			JAXBMarshaller jaxbMarshaller = new JAXBMarshaller();		
			System.out.println(jaxbMarshaller.generateXMLString("UTF-8", catalogElement, "milab.lab01.fooagent"));
		
		// ********************************************************************
		// *************** XML file, or String ---> Java Object ***************
		// ********************************************************************
		} else if (mode.equals("readfile")) {
			
			JAXBUnMarshaller jaxbUnMarshaller = new JAXBUnMarshaller();
			
			// ------------------- JAVA OBJECT -----------------------------------------------------------------------------------------------------------------------
			JAXBElement<CatalogType> catalogElement = (JAXBElement<CatalogType>)jaxbUnMarshaller.readXMLDocument(xmlDocument, "/jade/src/milab/lab01/fooagent/xsd/foo.xsd", "milab.lab01.fooagent");
			CatalogType catalog = catalogElement.getValue();

			System.out.println("Publisher: " + catalog.getPublisher());

			List<JournalType> journalList = catalog.getJournal();
			for (int i = 0; i < journalList.size(); i++) {

				JournalType journal = (JournalType)journalList.get(i);

				List<ArticleType> articleList = journal.getArticle();
				for (int j = 0; j < articleList.size(); j++) {
					
					ArticleType article = (ArticleType)articleList.get(j);
					System.out.println("Title: " + article.getTitle());
					System.out.println("Author: " + article.getAuthor());

				}
				
			}
			// ------------------- JAVA OBJECT ----------------------
		
		} else { // if (mode.equals("readstring")
			
			JAXBUnMarshaller jaxbUnMarshaller = new JAXBUnMarshaller();	
			
			// ------------------- JAVA OBJECT --------------------------------------------------------------------------------------------------------------------------------------------------
			JAXBElement<CatalogType> catalogElement = (JAXBElement<CatalogType>)jaxbUnMarshaller.readXMLString(DataHandler.readFile2String(xmlDocument), "/jade/src/milab/lab01/fooagent/xsd/foo.xsd", "milab.lab01.fooagent");
			CatalogType catalog = catalogElement.getValue();

			System.out.println("Publisher: " + catalog.getPublisher());

			List<JournalType> journalList = catalog.getJournal();
			for (int i = 0; i < journalList.size(); i++) {

				JournalType journal = (JournalType)journalList.get(i);

				List<ArticleType> articleList = journal.getArticle();
				for (int j = 0; j < articleList.size(); j++) {
					
					ArticleType article = (ArticleType)articleList.get(j);
					System.out.println("Title: " + article.getTitle());
					System.out.println("Author: " + article.getAuthor());

				}
				
			}
			// ------------------- JAVA OBJECT ----------------------
						
		}
		
	}
        
}